



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>在C++98基础上学习C++11新特性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">在C++98基础上学习C++11新特性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 07:08:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>自己一直用的是<em><strong>C++98</strong></em>规范来编程，对于<em><strong>C++11</strong></em>只闻其名却没用过其特性。近期因为工作的需要，需要掌握<em><strong>C++11</strong></em>的一些特性，所以查阅了一些<em><strong>C++11</strong></em>资料。因为自己有<em><strong>C++98</strong></em>的基础，所以从<em><strong>C++98</strong></em>过渡到<em><strong>C++11</strong></em>并不算特别吃力，读了一些书籍后，算是对<em><strong>C++11</strong></em>有了个比较基础的理解，感觉程序员还是要经常保持新语言新特性的更新，现在 <em><strong>C++</strong></em> 标准都出到<em><strong>C++17</strong></em>了！这篇文章就是对<em><strong>C++11</strong></em>一些常用新特性的一些总结，以<em><strong>C++98</strong></em>和 <em><strong>C++11</strong></em>在语法上的差异来突出<em><strong>C++11</strong></em>新特性的非凡优势。</p>
<h2>一、新语法</h2>
<h3>1.自动类型推导auto</h3>
<p>auto的自动推导，用于从初始化表达式中推断出变量的数据类型。</p>
<pre class="prettyprint linenums"><code><br />
//C++98<br />
int a = 10;<br />
string s = &quot;abc&quot;;<br />
float b = 10.0;<br />
vector&lt;int&gt; c;<br />
vector&lt;vector&lt;int&gt; &gt; d;<br />
map&lt;int, string&gt; m;<br />
m[1] = &quot;aaa&quot;;<br />
map&lt;int, string&gt;::iterator it = m.begin();

//C++11<br />
auto a1 = 10;  //a1为int<br />
auto s1 = &quot;abc&quot;;  //s1为string<br />
auto b1 = b;<br />
auto c1 = c;<br />
auto d1 = d;<br />
auto e1 = 'a';<br />
int* x = &amp;a1;<br />
auto d1 = x;<br />
auto m1 = m.begin();<br />
auto x=1,y=2; //ok<br />
auto i=1.j=3.14; //compile error

double a2 = 3.144;<br />
const auto a3 = a2;  //const double<br />
auto a4 = a2;  //double<br />
volatile int c2 = 3;<br />
auto c3 = c2; //int<br />
</code></pre>
<h3>2.萃取类型decltype</h3>
<p>decltype可以通过一个变量或表达式得到类型。</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

int add(int a)<br />
{<br />
    return ++a;<br />
}

void fun(int a)<br />
{<br />
    cout &lt;&lt; &quot;call function: [int]\n&quot; &lt;&lt; endl;<br />
}

void fun(int *a)<br />
{<br />
    cout &lt;&lt; &quot;call function: [int*]\n&quot; &lt;&lt; endl;<br />
}

int main()<br />
{<br />
    //C++11<br />
    int aa = 10;<br />
    decltype(aa) bb = 11;<br />
    string ss = &quot;hello intel&quot;;<br />
    decltype(ss) ss1 = &quot;hello&quot;;<br />
    const vector&lt;int&gt; vec(1);<br />
    decltype(vec[0]) cc = 1;<br />
    decltype(0) dd = vec[0];  //dd是int类型<br />
    decltype(add(1)) ee;  //int<br />
    int a[5];<br />
    decltype(a) ff; //int[5]<br />
    //decltype(fun) gg;  无法通过编译，是个重载函数

    return 0;<br />
}<br />
</code></pre>
<h3>3.nullptr</h3>
<p>空指针标识符nullptr是一个表示空指针的标识，他不是一个整数，这是与我们常用的NULL宏的区别。NULL只是一个定义为常整数0的宏，而nullptr是C++11的一个关键字，一个內建的标识符。</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

void fun(int a)<br />
{<br />
    cout &lt;&lt; &quot;call function: [int]\n&quot; &lt;&lt; endl;<br />
}

void fun(int *a)<br />
{<br />
    cout &lt;&lt; &quot;call function: [int*]\n&quot; &lt;&lt; endl;<br />
}

int main()<br />
{<br />
    //C++11<br />
    fun(NULL);   //call function: [int]<br />
    fun(nullptr);  //call function: [int*]

    int* p = NULL;<br />
    fun(p);  //call function: [int*]

    return 0;<br />
}<br />
</code></pre>
<h3>4.区间迭代range for</h3>
<p><em><strong>C++98</strong></em>和<em><strong>C++11</strong></em>在使用语法上的差异如下：</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

int main()<br />
{<br />
    //C++98<br />
    vector&lt;int&gt; vec(8, 1);<br />
    cout &lt;&lt; &quot;C++98 range for:&quot; &lt;&lt; endl;<br />
    for (vector&lt;int&gt;::iterator it = vec.begin(); it != vec.end(); it++)<br />
    {<br />
        cout &lt;&lt; *it &lt;&lt; endl;<br />
    }

    //C++11<br />
    cout &lt;&lt; &quot;C++11 range for:&quot; &lt;&lt; endl;<br />
    for (auto d : vec)<br />
    {<br />
        cout &lt;&lt; d &lt;&lt; endl;<br />
    }

    return 0;<br />
}<br />
</code></pre>
<p>值得指出的是，是否能够使用基于范围的for循环，必须依赖一些条件。首先，就是for循环迭代的范围是可确定的。对于类来说，如果该类有begin和end函数，那么for_each之间就是for循环迭代的范围。对于数组而言，就是数组的第一个和最后一个元素间的范围。其次，基于范围的for循环还要求迭代的对象实现+ + 和==等操作符。对于STL中的容器，如string、array、map等使用起来是不会有问题的。下面是C++11操作vector和数组的实践：</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

int main()<br />
{<br />
    vector&lt;int&gt; vec(8, 1);

    //C++11<br />
    cout &lt;&lt; &quot;C++11 value range for:&quot; &lt;&lt; endl;<br />
    /*d非引用，修改d不会影响vector里的值*/<br />
    for (auto d : vec)   //d中存储的是vec中的值<br />
    {<br />
        d = 2;<br />
    }

    for (auto d : vec)<br />
    {<br />
        cout &lt;&lt; d &lt;&lt; endl;<br />
    }

    cout &lt;&lt; &quot;C++11 reference range for:&quot; &lt;&lt; endl;<br />
    /*当迭代变量d为引用时，vector里的值可以被修改*/<br />
    for (auto &amp;d : vec)<br />
    {<br />
        d = 2;<br />
    }

    for (auto d : vec)<br />
    {<br />
        cout &lt;&lt; d &lt;&lt; endl;<br />
    }

    //数组for_each<br />
    char arr[] = {'a','b','c','d'};<br />
    for (auto &amp;d : arr)<br />
    {<br />
        d -= 32;<br />
    }<br />
    for (auto d : arr)<br />
    {<br />
        cout &lt;&lt; d &lt;&lt; endl;<br />
    }

    //遍历二维数组，注意迭代变量row必须为引用。如果你想用 range for 的方法，来遍历更高维的数组 （dim &gt; 2），那么你只需要：除了最内层循环之外，其他所有外层循环都加入 '&amp;' 即可。<br />
    int array2[5][5] = {0};<br />
    for (auto &amp;row : array2)<br />
        for (auto col : row)<br />
            cout &lt;&lt; col &lt;&lt; endl;

    return 0;<br />
}<br />
</code></pre>
<h3>5.返回类型后置语法</h3>
<p>先看下面这个例子，编译器在推导decltype(t1+t2)时表达式中t1和t2都未声明，所以编译失败。</p>
<pre class="prettyprint linenums"><code><br />
#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

template&lt;class T1, class T2&gt;<br />
decltype(t1 + t2) sum(T1 t1, T2 t2)<br />
{<br />
    return t1 + t2;<br />
}

int main()<br />
{<br />
    auto total = sum(1, 2);<br />
    cout &lt;&lt; total &lt;&lt; endl;<br />
    return 0;<br />
}<br />
</code></pre>
<p>所以C++11引入新语法，即把函数的返回值移至参数声明之后，复合符号-&gt;decltype(t1+t2)被称为追踪返回类型。而原本的函数返回值由auto占据。</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;vector&gt;

using namespace std;

template&lt;class T1, class T2&gt;<br />
auto sum(T1 t1, T2 t2) -&gt;decltype(t1+t2)<br />
{<br />
    return t1 + t2;<br />
}

int main()<br />
{<br />
    auto total = sum(1, 2);<br />
    cout &lt;&lt; total &lt;&lt; endl;<br />
    return 0;<br />
}

</code></pre>
<h3>6.final和override</h3>
<pre class="prettyprint linenums"><code>struct B<br />
{<br />
    virtual void f1(int) const;<br />
    virtual void f2();<br />
    void f3();<br />
};

struct D1 : public B<br />
{<br />
    void f1(int) const override;  //ok<br />
    void f2(int) override;   //error，B中没有形如f2(int)的函数<br />
    void f3() override;  //error，f3不是虚函数<br />
    void f4() override;  //error，B中无f4函数<br />
};

struct D2 : public B<br />
{<br />
    void f1(int) const final;  //不许后续的其他类覆盖<br />
};

struct D3 :public D2<br />
{<br />
    void f2();<br />
    void f1(int) const; //error，final函数不可覆盖<br />
};<br />
</code></pre>
<p>final还可以用于防止继承的发生</p>
<pre class="prettyprint linenums"><code>class NoDerived final<br />
{

};

class Bad :NoDerived   //NoDerived不可做基类<br />
{

};

class Base<br />
{

};

class Last final :Base<br />
{

};

class Bad2 :Last   //Last不可做基类<br />
{

};

</code></pre>
<h3>7.=default和=delete</h3>
<p>对于 C++ 的类，如果程序员没有为其定义特殊成员函数，那么在需要用到某个特殊成员函数的时候，编译器会隐式的自动生成一个默认的特殊成员函数，比如拷贝构造函数，或者拷贝赋值操作符。</p>
<p>C++11允许我们使用=default来要求编译器生成一个默认构造函数，也允许我们使用=delete来告诉编译器不要为我们生成某个默认函数</p>
<pre class="prettyprint linenums"><code>class B<br />
{<br />
    B() = default; //显示声明使用默认构造函数<br />
    B(const B&amp;) = delete; //禁止使用类对象之间的拷贝<br />
    ~B() = default;  //显示声明使用默认析构函数<br />
    B&amp; operator=(const B&amp;) = delete;  //禁止使用类对象之间的赋值<br />
    B(int a);<br />
};<br />
</code></pre>
<h3>8.lambda表达式</h3>
<p>简单来说，Lambda函数也就是一个函数（匿名函数），它的语法定义如下：</p>
<pre class="prettyprint linenums"><code>[capture](parameters) mutable -&gt;return-type{statement}<br />
</code></pre>
<ol><li>[=,&amp;a,&amp;b]表示以引用传递的方式捕捉变量a和b，以值传递方式捕捉其它所有变量;</li>
<li>[&amp;,a,this]表示以值传递的方式捕捉变量a和类的this指针，引用传递方式捕捉其它所有变量。</li></ol>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;

using namespace std;

int main()<br />
{<br />
    auto f = []() {cout &lt;&lt; &quot;hello world!&quot; &lt;&lt; endl; };<br />
    f();  //hello world!

    int a = 123;<br />
    auto f1 = [a] { cout &lt;&lt; a &lt;&lt; endl; };<br />
    f1();  //123

    auto f2 = [&amp;a] {cout &lt;&lt; a &lt;&lt; endl; };<br />
    a = 789;<br />
    f2();  //789

    //隐式捕获:让编译器根据函数体中的代码来推断需要捕获哪些变量<br />
    auto f3 = [=] {cout &lt;&lt; a &lt;&lt; endl; };<br />
    f3();  //789

    auto f4 = [&amp;] {cout &lt;&lt; a &lt;&lt; endl; };<br />
    a = 990;<br />
    f4();  //990

    auto f5 = [](int a, int b)-&gt;int {return a + b; };<br />
    printf(&quot;%d\n&quot;, f5(1, 2));  //3

    return 0;<br />
}<br />
</code></pre>
<p>lambda表达式在C++下的应用，排序</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;vector&gt;

using namespace std;

void print(char arr[], int len)<br />
{<br />
    for (int i = 0; i &lt; len; i++)<br />
    {<br />
        printf(&quot;%d &quot;, arr[i]);<br />
    }<br />
    printf(&quot;\n&quot;);<br />
}

bool cmp(char a, char b)<br />
{<br />
    if (a &gt; b)<br />
        return true;<br />
    else<br />
        return false;<br />
}

int main()<br />
{<br />
    //c++98<br />
    char arr1[] = { 2,5,2,1,5,89,36,22,89 };<br />
    int len = sizeof(arr1) / sizeof(char);<br />
    sort(arr1, arr1 + len, cmp);<br />
    print(arr1, len);

    //c++11<br />
    char arr2[] = { 2,5,2,1,5,89,36,22,89 };<br />
    int len2 = sizeof(arr2) / sizeof(char);<br />
    sort(arr2, arr2 + len2, [](char a, char b)-&gt;bool {return a &gt; b; });<br />
    print(arr2, len2);<br />
    return 0;<br />
}<br />
</code></pre>
<h3>9.std::move</h3>
<p>std::move是为性能而生，通过std::move，可以避免不必要的拷贝操作。std::move是将对象的状态或者所有权从一个对象转移到另一个对象，只是转移，没有内存的搬迁或者内存拷贝。</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;utility&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;string&gt;<br />
int main()<br />
{<br />
    std::string str = &quot;Hello&quot;;<br />
    std::vector&lt;std::string&gt; v;<br />
    //调用常规的拷贝构造函数，新建字符数组，拷贝数据<br />
    v.push_back(str);<br />
    std::cout &lt;&lt; &quot;After copy, str is \&quot;&quot; &lt;&lt; str &lt;&lt; &quot;\&quot;\n&quot;; //After move, str is &quot;Hello&quot;<br />
    //调用移动构造函数，掏空str，掏空后，最好不要使用str<br />
    v.push_back(std::move(str));<br />
    std::cout &lt;&lt; &quot;After move, str is \&quot;&quot; &lt;&lt; str &lt;&lt; &quot;\&quot;\n&quot;;   //After move, str is &quot;&quot;<br />
    std::cout &lt;&lt; &quot;The contents of the vector are \&quot;&quot; &lt;&lt; v[0]<br />
        &lt;&lt; &quot;\&quot;, \&quot;&quot; &lt;&lt; v[1] &lt;&lt; &quot;\&quot;\n&quot;;   //The contents of the vector are &quot;Hello&quot;, &quot;Hello&quot;<br />
}<br />
</code></pre>
<h2>二、STL新内容</h2>
<h3>1.std::array</h3>
<ol><li><p>使用 std::array保存在栈内存中，相比堆内存中的 std::vector，我们就能够灵活的访问这里面的元素，从而获得更高的性能；同时正式由于其堆内存存储的特性，有些时候我们还需要自己负责释放这些资源。</p></li>
<li><p>使用std::array能够让代码变得更加现代，且封装了一些操作函数，同时还能够友好的使用标准库中的容器算法等等，比如 std::sort。</p></li></ol>
<p>std::array 会在编译时创建一个固定大小的数组，std::array 不能够被隐式的转换成指针，使用 std::array 很简单，只需指定其类型和大小即可：</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;array&gt;

void foo(int* p)<br />
{

}

int main()<br />
{<br />
    std::array&lt;int, 4&gt; arr = {4,3,1,2};

    foo(&amp;arr[0]);  //OK<br />
    foo(arr.data());  //OK<br />
    //foo(arr);  //wrong<br />
    std::sort(arr.begin(), arr.end());  //排序

    return 0;<br />
}

</code></pre>
<h3>2.std::forward_list</h3>
<p>std::forward_list 使用单向链表进行实现，提供了 O(1)    复杂度的元素插入，不支持快速随机访问（这也是链表的特点），也是标准库容器中唯一一个不提供 size() 方法的容器。当不需要双向迭代时，具有比 std::list 更高的空间利用率。</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;string&gt;<br />
#include &lt;forward_list&gt;

int main()<br />
{<br />
    std::forward_list&lt;int&gt; list1 = { 1, 2, 3, 4 };

    //从前面向foo1容器中添加数据，注意不支持push_back<br />
    list1.pop_front();  //删除链表第一个元素<br />
    list1.remove(3);   //删除链表值为3的节点<br />
    list1.push_front(2);<br />
    list1.push_front(1);<br />
    list1.push_front(14);<br />
    list1.push_front(17);

    list1.sort();

    for (auto &amp;n : list1)<br />
    {<br />
        if (n == 17)<br />
            n = 19;<br />
    }

    for (const auto &amp;n : list1)<br />
    {<br />
        std::cout &lt;&lt; n &lt;&lt; std::endl;  //1 2 2 4 14 19<br />
    }

    return 0;<br />
}<br />
</code></pre>
<h3>3.std::unordered_map和std::unordered_set</h3>
<p>无序容器中的元素是不进行排序的，内部通过 Hash 表实现，插入和搜索元素的平均复杂度为 O(constant)，在不关心容器内部元素顺序时，能够获得显著的性能提升。</p>
<p>C++11 引入了两组无序容器：std::unordered_map/std::unordered_multimap 和 std::unordered_set/std::unordered_multiset。</p>
<p>下面给出unordered_map和unordered_set的使用方法。</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;string&gt;<br />
#include &lt;unordered_map&gt;<br />
#include &lt;unordered_set&gt;

void foo(int* p)<br />
{

}

int main()<br />
{<br />
    //unordered_map usage<br />
    std::unordered_map&lt;std::string, int&gt; um = { {&quot;2&quot;,2},{&quot;1&quot;,1},{&quot;3&quot;,3} };

    //遍历<br />
    for (const auto &amp;n : um)<br />
    {<br />
        std::cout &lt;&lt; &quot;key:&quot; &lt;&lt; n.first &lt;&lt; &quot;  value:&quot; &lt;&lt; n.second &lt;&lt; std::endl;<br />
    }

    std::cout &lt;&lt; &quot;value:&quot; &lt;&lt; um[&quot;1&quot;] &lt;&lt; std::endl;

    //unordered_set usage<br />
    std::unordered_set&lt;int&gt; us = { 2,3,4,1};

    //遍历<br />
    for (const auto &amp;n : us)<br />
    {<br />
        std::cout &lt;&lt; &quot;value:&quot; &lt;&lt; n &lt;&lt; std::endl;<br />
    }

    std::cout &lt;&lt; &quot;value:&quot; &lt;&lt; us.count(9) &lt;&lt; std::endl; //判断一个数是否在集合内，1存在0不存在<br />
    std::cout &lt;&lt; &quot;value:&quot; &lt;&lt; *us.find(1) &lt;&lt; std::endl;  //查找一个特定的数是否在集合内，找到就返回该数的迭代器位置

    return 0;<br />
}<br />
</code></pre>
<h2>三、智能指针</h2>
<h3>1. std::shared_ptr</h3>
<p>shared_ptr使用引用计数，每一个shared_ptr的拷贝都指向相同的内存。每使用他一次，内部的引用计数加1，每析构一次，内部的引用计数减1，减为0时，删除所指向的堆内存。shared_ptr内部的引用计数是安全的，但是对象的读取需要加锁。</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;memory&gt;<br />
#include &lt;iostream&gt;

int main()<br />
{<br />
    //auto ptr = std::make_shared&lt;int&gt;(10);<br />
    std::shared_ptr&lt;int&gt; ptr(new int(10));<br />
    std::shared_ptr&lt;int&gt; ptrC(ptr);

    auto ptr2 = ptr;

    {<br />
        auto ptr3 = ptr2;<br />
        std::cout &lt;&lt; &quot;pointer1.use_count() = &quot; &lt;&lt; ptr.use_count() &lt;&lt; std::endl;  //4<br />
        std::cout &lt;&lt; &quot;pointer2.use_count() = &quot; &lt;&lt; ptr2.use_count() &lt;&lt; std::endl;  //4<br />
    }

    std::cout &lt;&lt; &quot;pointer1.use_count() = &quot; &lt;&lt; ptr.use_count() &lt;&lt; std::endl;  //3<br />
    std::cout &lt;&lt; &quot;pointer2.use_count() = &quot; &lt;&lt; ptr2.use_count() &lt;&lt; std::endl;  //3

    int *p = ptr.get(); //获取原始指针

    std::cout &lt;&lt; &quot;pointer1.use_count() = &quot; &lt;&lt; ptr.use_count() &lt;&lt; std::endl;  //3<br />
    std::cout &lt;&lt; &quot;pointer2.use_count() = &quot; &lt;&lt; ptr2.use_count() &lt;&lt; std::endl;  //3

    return 0;<br />
}<br />
</code></pre>
<h2>3 2. std::unique_ptr</h2>
<p>std::unique_ptr 是一种独占的智能指针，它禁止其他智能指针与其共享同一个对象，从而保证代码的安全：</p>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;memory&gt;<br />
#include &lt;iostream&gt;

int main()<br />
{<br />
    std::unique_ptr&lt;int&gt; ptr(new int(10));<br />
    //auto ptr2 = ptr; //非法

    //虽说unique_ptr是不可复制的，但我们可以使用std::move将其独占权转移到其他的unique_ptr<br />
    auto ptr2(std::move(ptr));<br />
    std::cout &lt;&lt; *ptr2 &lt;&lt; std::endl;

    return 0;<br />
}<br />
</code></pre>
<h3>3. std::weak_ptr</h3>
<p>先观察下面的代码，如果我们在类father中使用的是shared_ptr son的话，father和son的实例并没有顺利回收，输出如下：</p>
<pre class="prettyprint linenums"><code>father !<br />
son !<br />
</code></pre>
<p>以上问题就是shared_ptr的环形引用问题。为了避免shared_ptr的环形引用问题，需要引入一个弱引用weak_ptr， weak_ptr是为了配合shared_ptr而引入的一种智能指针，弱引用不会引起引用计数增加,它更像是shared_ptr的一个助手而不是智能指针，因为它不具有普通指针的行为，没有重载operator*和-&gt;,它的最大作用在于协助shared_ptr工作，像旁观者那样观测资源的使用情况.</p>
<pre class="prettyprint linenums"><code>#include &lt;iostream&gt;<br />
#include &lt;memory&gt;<br />
using namespace std;

class father;<br />
class son;

class father {<br />
public:<br />
    father() {<br />
        cout &lt;&lt; &quot;father !&quot; &lt;&lt; endl;<br />
    }<br />
    ~father() {<br />
        cout &lt;&lt; &quot;~~~~~father !&quot; &lt;&lt; endl;<br />
    }<br />
    void setSon(shared_ptr&lt;son&gt; s) {<br />
        son = s;<br />
    }<br />
private:<br />
    //shared_ptr&lt;son&gt; son;<br />
    weak_ptr&lt;son&gt; son; // 用weak_ptr来替换<br />
};

class son {<br />
public:<br />
    son() {<br />
        cout &lt;&lt; &quot;son !&quot; &lt;&lt; endl;<br />
    }<br />
    ~son() {<br />
        cout &lt;&lt; &quot;~~~~~~son !&quot; &lt;&lt; endl;<br />
    }<br />
    void setFather(shared_ptr&lt;father&gt; f) {<br />
        father = f;<br />
    }<br />
private:<br />
    shared_ptr&lt;father&gt; father;<br />
};

void test() {<br />
    shared_ptr&lt;father&gt; f(new father());<br />
    shared_ptr&lt;son&gt; s(new son());<br />
    f-&gt;setSon(s);<br />
    s-&gt;setFather(f);<br />
}

int main()<br />
{<br />
    test();<br />
    return 0;<br />
}<br />
</code></pre>
<p>输出：</p>
<pre class="prettyprint linenums"><code>father !<br />
son !<br />
~~~~~~son !<br />
~~~~~father !<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93gdl08.html">asp&period;net中打印指定控件内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4vprnq.html">python抓取数据 常见反爬虫 情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw3pry9.html">Objective-C之集合对象的内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnrryj9.html">Java基础之集合框架&mdash;&mdash;使用真的的链表LinkedList&amp;lt&semi;&amp;gt&semi;（TryPolyLine）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xn4xz9.html">南阳理工ACM954--N&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmz4jz9.html">&lbrack;原创&rsqb; CSS总结！！ 有关HTML第二篇  ！！</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ox62j9.html">mysqlbinlog 读取多个文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dzp2q.html">Java自学资料&mdash;&mdash;线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p5rgn8.html">C&plus;&plus;中进制转换问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myw1j8.html">基于FPGA的均值滤波算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pzyk38.html">SimpleDateFormat 常规用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kplwo79.html">搭建maven</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6yj69.html">逆天的 GRUB</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwk6zd8.html">&lbrack;C&plus;&plus;&rsqb;PAT乙级1009&period; 说反话 &lpar;17&sol;20&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdx759.html">【SDOI2009】Bill的挑战</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw0wp78.html">Haskell语言学习笔记（79）lambda演算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv1x438.html">cf-Global Round2-E&period; Pavel and Triangles</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kom747q.html">C&num; ArcEngine TOCControl上实现右键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlxxvk9.html">OPENCV----在APP性能测试中的应用（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmkvow9.html">判断浏览器内核JS代码</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pwpz48.html">【linux】mkfifo 命令创建命名管道实现进程之间通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kgmm8.html">（十一）延时执行、圆角（可实现圆形label）、代理设计模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxr3n8.html">Xcode中的调试工具栏简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1m26zq.html">自己动手写web框架----1</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyl4dz9.html">Android安全机制浅谈-android学习之旅（80）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zyl2x9.html">java 编程性能调优</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj3n769.html">Shell编程入门&lpar;第二版&rpar;&lpar;下&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgvr79.html">iOS9 系统分享调用（UIActivityViewController）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pwdgy8.html">Linux内核中断和异常分析&lpar;下&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me7yp2q.html">熊猫猪新系统测试之四&colon;Ubuntu 14&period;04</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
